=== modified file 'bzrlib/groupcompress.py'
--- bzrlib/groupcompress.py	2009-03-14 16:01:16 +0000
+++ bzrlib/groupcompress.py	2009-03-14 16:05:43 +0000
@@ -201,6 +201,11 @@
             self._content = zlib.decompress(self._z_content)
         self._z_content = None
 
+    def _ensure_content(self):
+        """Make sure that content has been expanded."""
+        if self._content is None:
+            self._expand_content()
+
     def _parse_bytes(self, bytes):
         """Read the various lengths from the header.
 
@@ -248,7 +253,7 @@
         out._parse_bytes(bytes)
         if not _NO_LABELS:
             out._parse_header()
-        out._expand_content()
+        # out._expand_content()
         return out
 
     def extract(self, key, index_memo, sha1=None):
@@ -258,6 +263,7 @@
         :param sha1: TODO (should we validate only when sha1 is supplied?)
         :return: The bytes for the content
         """
+        self._ensure_content()
         if _NO_LABELS or not self._entries:
             start, end = index_memo[3:5]
             # The bytes are 'f' or 'd' for the type, then a variable-length

=== modified file 'bzrlib/tests/test_groupcompress.py'
--- bzrlib/tests/test_groupcompress.py	2009-03-14 16:01:16 +0000
+++ bzrlib/tests/test_groupcompress.py	2009-03-14 16:05:43 +0000
@@ -194,7 +194,12 @@
             'gcb1z\n0\n0\n0\n0\n')
         self.assertIsInstance(block, groupcompress.GroupCompressBlock)
         self.assertEqual({}, block._entries)
+        self.assertIs(None, block._content)
+        self.assertEqual('', block._z_content)
+        block._ensure_content()
         self.assertEqual('', block._content)
+        self.assertIs(None, block._z_content)
+        block._ensure_content() # Ensure content is safe to call 2x
 
     def test_from_bytes(self):
         header = ('key:bing\n'
@@ -239,6 +244,10 @@
         self.assertEqual('abcd'*10, foobar.sha1)
         self.assertEqual(0, foobar.start)
         self.assertEqual(100, foobar.length)
+        self.assertEqual(z_content, block._z_content)
+        self.assertIs(None, block._content)
+        block._ensure_content()
+        self.assertIs(None, block._z_content)
         self.assertEqual(content, block._content)
 
     def test_add_entry(self):

